## org.apache.lucene.index
Class FilterIndexReader

    java.lang.Object
      org.apache.lucene.index.IndexReader
          org.apache.lucene.index.FilterIndexReader

    public class FilterIndexReader

extends IndexReader

A `FilterIndexReader` contains another IndexReader, which it uses as its basic source of data, possibly transforming the data along the way or providing additional functionality. The class `FilterIndexReader` itself simply implements all abstract methods of `IndexReader` with versions that pass all requests to the contained index reader. Subclasses of `FilterIndexReader` may further override some of these methods and may also provide additional methods and fields.

Nested Class Summary
`static class` `FilterIndexReader.FilterTermDocs` Base class for filtering `TermDocs` implementations.
`static class` `FilterIndexReader.FilterTermEnum` Base class for filtering `TermEnum` implementations.
`static class` `FilterIndexReader.FilterTermPositions` Base class for filtering `TermPositions` implementations.

Nested classes/interfaces inherited from class org.apache.lucene.index.IndexReader
`IndexReader.FieldOption`

Field Summary
`protected IndexReader` `in`

Fields inherited from class org.apache.lucene.index.IndexReader
`hasChanges`

Constructor Summary
`FilterIndexReader(IndexReader in)` Construct a FilterIndexReader based on the specified base reader.

Method Summary
`Directory` `directory()` Returns the directory associated with this index.
`int` `docFreq(Term t)` Returns the number of documents containing the term `t`.
`protected void` `doClose()` Implements close.
`protected void` `doCommit()` Implements commit.
`Document` `document(int n, FieldSelector fieldSelector)` Get the `Document` at the `n`th position.
`protected void` `doDelete(int n)` Implements deletion of the document numbered `docNum`.
`protected void` `doSetNorm(int d, String f, byte b)` Implements setNorm in subclass.
`protected void` `doUndeleteAll()` Implements actual undeleteAll() in subclass.
`Collection` `getFieldNames(IndexReader.FieldOption fieldNames)` Get a list of unique field names that exist in this index and have the specified field option information.
`TermFreqVector` `getTermFreqVector(int docNumber, String field)` Return a term frequency vector for the specified document and field.
`void` `getTermFreqVector(int docNumber, String field, TermVectorMapper mapper)` Load the Term Vector into a user-defined data structure instead of relying on the parallel arrays of the `TermFreqVector`.
`void` `getTermFreqVector(int docNumber, TermVectorMapper mapper)` Map all the term vectors for all fields in a Document
`TermFreqVector[]` `getTermFreqVectors(int docNumber)` Return an array of term frequency vectors for the specified document.
`long` `getVersion()` Version number when this IndexReader was opened.
`boolean` `hasDeletions()` Returns true if any documents have been deleted
`boolean` `hasNorms(String field)` Returns true if there are norms stored for this field.
`boolean` `isCurrent()` Check whether this IndexReader is still using the current (i.e., most recently committed) version of the index.
`boolean` `isDeleted(int n)` Returns true if document n has been deleted
`boolean` `isOptimized()` Checks is the index is optimized (if it has a single segment and no deletions).
`int` `maxDoc()` Returns one greater than the largest possible document number.
`byte[]` `norms(String f)` Returns the byte-encoded normalization factor for the named field of every document.
`void` `norms(String f, byte[] bytes, int offset)` Reads the byte-encoded normalization factor for the named field of every document.
`int` `numDocs()` Returns the number of documents in this index.
`TermDocs` `termDocs()` Returns an unpositioned `TermDocs` enumerator.
`TermPositions` `termPositions()` Returns an unpositioned `TermPositions` enumerator.
`TermEnum` `terms()` Returns an enumeration of all the terms in the index.
`TermEnum` `terms(Term t)` Returns an enumeration of all terms starting at a given term.

Methods inherited from class org.apache.lucene.index.IndexReader

`acquireWriteLock, close, commit, decRef, deleteDocument, deleteDocuments, document, ensureOpen, flush, getCurrentVersion, getCurrentVersion, getCurrentVersion, getTermInfosIndexDivisor, incRef, indexExists, indexExists, indexExists, isLocked, isLocked, lastModified, lastModified, lastModified, main, open, open, open, open, reopen, setNorm, setNorm, setTermInfosIndexDivisor, termDocs, termPositions, undeleteAll, unlock`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### in

    protected IndexReader in

Constructor Detail

### FilterIndexReader

    public FilterIndexReader(IndexReader in)

  Construct a FilterIndexReader based on the specified base reader. Directory locking for delete, undeleteAll, and setNorm operations is left to the base reader.

  Note that base reader is closed if this FilterIndexReader is closed.

  Parameters:
    `in` - specified base reader.

Method Detail

### directory

    public Directory directory()

  Description copied from class: `IndexReader`
  Returns the directory associated with this index. The Default implementation returns the directory specified by subclasses when delegating to the IndexReader(Directory) constructor, or throws an UnsupportedOperationException if one was not specified.

  Overrides:
    `directory` in class `IndexReader`

### getTermFreqVectors

    public TermFreqVector[] getTermFreqVectors(int docNumber)
                                        throws IOException

  Description copied from class: `IndexReader`
  Return an array of term frequency vectors for the specified document. The array contains a vector for each vectorized field in the document. Each vector contains terms and frequencies for all terms in a given vectorized field. If no such fields existed, the method returns null. The term vectors that are returned my either be of type TermFreqVector or of type TermPositionsVector if positions or offsets have been stored.

  Specified by:
    `getTermFreqVectors` in class `IndexReader`
  Parameters:
    `docNumber` - document for which term frequency vectors are returned
  Returns:
    array of term frequency vectors. May be null if no term vectors have been stored for the specified document.
  Throws:
    `IOException` - if index cannot be accessed
  See Also:
    `Field.TermVector`

### getTermFreqVector

    public TermFreqVector getTermFreqVector(int docNumber,
                                            String field)
                                     throws IOException

  Description copied from class: `IndexReader`
  Return a term frequency vector for the specified document and field. The returned vector contains terms and frequencies for the terms in the specified field of this document, if the field had the storeTermVector flag set. If termvectors had been stored with positions or offsets, a TermPositionsVector is returned.

  Specified by:
    `getTermFreqVector` in class `IndexReader`
  Parameters:
    `docNumber` - document for which the term frequency vector is returned
    `field` - field for which the term frequency vector is returned.
  Returns:
    term frequency vector May be null if field does not exist in the specified document or term vector was not stored.
  Throws:
    `IOException` - if index cannot be accessed
  See Also:
    `Field.TermVector`

### getTermFreqVector

    public void getTermFreqVector(int docNumber,
                                  String field,
                                  TermVectorMapper mapper)
                           throws IOException

  Description copied from class: `IndexReader`
  Load the Term Vector into a user-defined data structure instead of relying on the parallel arrays of the `TermFreqVector`.

  Specified by:
    `getTermFreqVector` in class `IndexReader`
  Parameters:
    `docNumber` - The number of the document to load the vector for
    `field` - The name of the field to load
    `mapper` - The `TermVectorMapper` to process the vector. Must not be null
  Throws:
    `IOException` - if term vectors cannot be accessed or if they do not exist on the field and doc. specified.

### getTermFreqVector

    public void getTermFreqVector(int docNumber,
                                  TermVectorMapper mapper)
                           throws IOException

  Description copied from class: `IndexReader`
  Map all the term vectors for all fields in a Document

  Specified by:
    `getTermFreqVector` in class `IndexReader`
  Parameters:
    `docNumber` - The number of the document to load the vector for
    `mapper` - The `TermVectorMapper` to process the vector. Must not be null
  Throws:
    `IOException` - if term vectors cannot be accessed or if they do not exist on the field and doc. specified.

### numDocs

    public int numDocs()

  Description copied from class: `IndexReader`
  Returns the number of documents in this index.

  Specified by:
    `numDocs` in class `IndexReader`

### maxDoc

    public int maxDoc()

  Description copied from class: `IndexReader`
  Returns one greater than the largest possible document number. This may be used to, e.g., determine how big to allocate an array which will have an element for every document number in an index.

  Specified by:
    `maxDoc` in class `IndexReader`

### document

    public Document document(int n,
                             FieldSelector fieldSelector)
                      throws CorruptIndexException,
                             IOException

  Description copied from class: `IndexReader`
  Get the `Document` at the `n`th position. The `FieldSelector` may be used to determine what `Field`s to load and how they should be loaded. NOTE: If this Reader (more specifically, the underlying `FieldsReader`) is closed before the lazy `Field` is loaded an exception may be thrown. If you want the value of a lazy `Field` to be available after closing you must explicitly load it or fetch the Document again with a new loader.

  Specified by:
    `document` in class `IndexReader`
  Parameters:
    `n` - Get the document at the `n`th position
    `fieldSelector` - The `FieldSelector` to use to determine what Fields should be loaded on the Document. May be null, in which case all Fields will be loaded.
  Returns:
    The stored fields of the `Document` at the nth position
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error
  See Also:
    `Fieldable`, `FieldSelector`, `SetBasedFieldSelector`, `LoadFirstFieldSelector`

### isDeleted

    public boolean isDeleted(int n)

  Description copied from class: `IndexReader`
  Returns true if document n has been deleted

  Specified by:
    `isDeleted` in class `IndexReader`

### hasDeletions

    public boolean hasDeletions()

  Description copied from class: `IndexReader`
  Returns true if any documents have been deleted

  Specified by:
    `hasDeletions` in class `IndexReader`

### doUndeleteAll

    protected void doUndeleteAll()
                          throws CorruptIndexException,
                                 IOException

  Description copied from class: `IndexReader`
  Implements actual undeleteAll() in subclass.

  Specified by:
    `doUndeleteAll` in class `IndexReader`
  Throws:
    `CorruptIndexException`
    `IOException`

### hasNorms

    public boolean hasNorms(String field)
                     throws IOException

  Description copied from class: `IndexReader`
  Returns true if there are norms stored for this field.

  Overrides:
    `hasNorms` in class `IndexReader`
  Throws:
    `IOException`

### norms

    public byte[] norms(String f)
                 throws IOException

  Description copied from class: `IndexReader`
  Returns the byte-encoded normalization factor for the named field of every document. This is used by the search code to score documents.

  Specified by:
    `norms` in class `IndexReader`
  Throws:
    `IOException`
  See Also:
    `AbstractField.setBoost(float)`

### norms

    public void norms(String f,
                      byte[] bytes,
                      int offset)
               throws IOException

  Description copied from class: `IndexReader`
  Reads the byte-encoded normalization factor for the named field of every document. This is used by the search code to score documents.

  Specified by:
    `norms` in class `IndexReader`
  Throws:
    `IOException`
  See Also:
    `AbstractField.setBoost(float)`

### doSetNorm

    protected void doSetNorm(int d,
                             String f,
                             byte b)
                      throws CorruptIndexException,
                             IOException

  Description copied from class: `IndexReader`
  Implements setNorm in subclass.

  Specified by:
    `doSetNorm` in class `IndexReader`
  Throws:
    `CorruptIndexException`
    `IOException`

### terms

    public TermEnum terms()
                   throws IOException

  Description copied from class: `IndexReader`
  Returns an enumeration of all the terms in the index. The enumeration is ordered by Term.compareTo(). Each term is greater than all that precede it in the enumeration. Note that after calling terms(), `TermEnum.next()` must be called on the resulting enumeration before calling other methods such as `TermEnum.term()`.

  Specified by:
    `terms` in class `IndexReader`
  Throws:
    `IOException` - if there is a low-level IO error

### terms

    public TermEnum terms(Term t)
                   throws IOException

  Description copied from class: `IndexReader`
  Returns an enumeration of all terms starting at a given term. If the given term does not exist, the enumeration is positioned at the first term greater than the supplied therm. The enumeration is ordered by Term.compareTo(). Each term is greater than all that precede it in the enumeration.

  Specified by:
    `terms` in class `IndexReader`
  Throws:
    `IOException` - if there is a low-level IO error

### docFreq

    public int docFreq(Term t)
                throws IOException

  Description copied from class: `IndexReader`
  Returns the number of documents containing the term `t`.

  Specified by:
    `docFreq` in class `IndexReader`
  Throws:
    `IOException` - if there is a low-level IO error

### termDocs

    public TermDocs termDocs()
                      throws IOException

  Description copied from class: `IndexReader`
  Returns an unpositioned `TermDocs` enumerator.

  Specified by:
    `termDocs` in class `IndexReader`
  Throws:
    `IOException` - if there is a low-level IO error

### termPositions

    public TermPositions termPositions()
                                throws IOException

  Description copied from class: `IndexReader`
  Returns an unpositioned `TermPositions` enumerator.

  Specified by:
    `termPositions` in class `IndexReader`
  Throws:
    `IOException` - if there is a low-level IO error

### doDelete

    protected void doDelete(int n)
                     throws CorruptIndexException,
                            IOException

  Description copied from class: `IndexReader`
  Implements deletion of the document numbered `docNum`. Applications should call `IndexReader.deleteDocument(int)` or `IndexReader.deleteDocuments(Term)`.

  Specified by:
    `doDelete` in class `IndexReader`
  Throws:
    `CorruptIndexException`
    `IOException`

### doCommit

    protected void doCommit()
                     throws IOException

  Description copied from class: `IndexReader`
  Implements commit.

  Specified by:
    `doCommit` in class `IndexReader`
  Throws:
    `IOException`

### doClose

    protected void doClose()
                    throws IOException

  Description copied from class: `IndexReader`
  Implements close.

  Specified by:
    `doClose` in class `IndexReader`
  Throws:
    `IOException`

### getFieldNames

    public Collection getFieldNames(IndexReader.FieldOption fieldNames)

  Description copied from class: `IndexReader`
  Get a list of unique field names that exist in this index and have the specified field option information.

  Specified by:
    `getFieldNames` in class `IndexReader`
  Parameters:
    `fieldNames` - specifies which field option should be available for the returned fields
  Returns:
    Collection of Strings indicating the names of the fields.
  See Also:
    `IndexReader.FieldOption`

### getVersion

    public long getVersion()

  Description copied from class: `IndexReader`
  Version number when this IndexReader was opened. Not implemented in the IndexReader base class.

  Overrides:
    `getVersion` in class `IndexReader`

### isCurrent

    public boolean isCurrent()
                      throws CorruptIndexException,
                             IOException

  Description copied from class: `IndexReader`
  Check whether this IndexReader is still using the current (i.e., most recently committed) version of the index. If a writer has committed any changes to the index since this reader was opened, this will return `false`, in which case you must open a new IndexReader in order to see the changes. See the description of the `autoCommit` flag which controls when the `IndexWriter` actually commits changes to the index.

  Not implemented in the IndexReader base class.

  Overrides:
    `isCurrent` in class `IndexReader`
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error

### isOptimized

    public boolean isOptimized()

  Description copied from class: `IndexReader`
  Checks is the index is optimized (if it has a single segment and no deletions). Not implemented in the IndexReader base class.

  Overrides:
    `isOptimized` in class `IndexReader`
  Returns:
    `true` if the index is optimized; `false` otherwise

Copyright © 2000-2008 Apache Software Foundation. All Rights Reserved.